Index: WebCore/GNUmakefile.am
===================================================================
--- WebCore/GNUmakefile.am	(revision 35758)
+++ WebCore/GNUmakefile.am	(working copy)
@@ -2,6 +2,7 @@
 WebCore := $(srcdir)/WebCore
 
 FEATURE_DEFINES_JAVASCRIPT := LANGUAGE_JAVASCRIPT=1
+FEATURE_DEFINES_GDOM := LANGUAGE_GOBJECT=1
 SVG_FEATURES :=
 HTML_FEATURES :=
 
@@ -9,6 +10,7 @@
 WEBCORE_CSS_VALUE_KEYWORDS := $(WebCore)/css/CSSValueKeywords.in
 
 webcore_cppflags += \
+	-I$(srcdir)/WebKit/gtk \
 	-I$(srcdir)/WebCore \
 	-I$(srcdir)/WebCore/platform \
 	-I$(srcdir)/WebCore/platform/network \
@@ -29,6 +31,7 @@
 	-I$(srcdir)/WebCore/xml \
 	-I$(srcdir)/WebCore/html \
 	-I$(srcdir)/WebCore/bindings/js \
+	-I$(srcdir)/WebCore/bindings/gdom \
 	-I$(srcdir)/WebCore/platform/image-decoders \
 	-I$(srcdir)/WebCore/platform/image-decoders/bmp \
 	-I$(srcdir)/WebCore/platform/image-decoders/gif \
@@ -55,7 +58,7 @@
 	WebCore/bindings/js/JSDOMWindowBase.lut.h \
 	WebCore/bindings/js/JSEventTargetBase.lut.h \
 	WebCore/bindings/js/JSRGBColor.lut.h \
-	WebCore/bindings/js/JSHTMLInputElementBaseTable.cpp
+	WebCore/bindings/js/JSHTMLInputElementBaseTable.cpp 
 
 webcore_built_sources += \
 	DerivedSources/CSSGrammar.cpp \
@@ -358,7 +361,587 @@
 	DerivedSources/UserAgentStyleSheets.h \
 	DerivedSources/UserAgentStyleSheetsData.cpp \
 	DerivedSources/XMLNames.cpp \
-	DerivedSources/XMLNames.h
+	DerivedSources/XMLNames.h \
+	DerivedSources/GdomAttr.cpp \
+	DerivedSources/GdomAttr.h \
+	DerivedSources/GdomBarInfo.cpp \
+	DerivedSources/GdomBarInfo.h \
+	DerivedSources/GdomCDATASection.cpp \
+	DerivedSources/GdomCDATASection.h \
+	DerivedSources/GdomCSSCharsetRule.cpp \
+	DerivedSources/GdomCSSCharsetRule.h \
+	DerivedSources/GdomCSSFontFaceRule.cpp \
+	DerivedSources/GdomCSSFontFaceRule.h \
+	DerivedSources/GdomCSSImportRule.cpp \
+	DerivedSources/GdomCSSImportRule.h \
+	DerivedSources/GdomCSSMediaRule.cpp \
+	DerivedSources/GdomCSSMediaRule.h \
+	DerivedSources/GdomCSSPageRule.cpp \
+	DerivedSources/GdomCSSPageRule.h \
+	DerivedSources/GdomCSSPrimitiveValue.cpp \
+	DerivedSources/GdomCSSPrimitiveValue.h \
+	DerivedSources/GdomCSSRule.cpp \
+	DerivedSources/GdomCSSRule.h \
+	DerivedSources/GdomCSSRuleList.cpp \
+	DerivedSources/GdomCSSRuleList.h \
+	DerivedSources/GdomCSSStyleDeclaration.cpp \
+	DerivedSources/GdomCSSStyleDeclaration.h \
+	DerivedSources/GdomCSSStyleRule.cpp \
+	DerivedSources/GdomCSSStyleRule.h \
+	DerivedSources/GdomCSSStyleSheet.cpp \
+	DerivedSources/GdomCSSStyleSheet.h \
+	DerivedSources/GdomCSSValue.cpp \
+	DerivedSources/GdomCSSValue.h \
+	DerivedSources/GdomCSSValueList.cpp \
+	DerivedSources/GdomCSSValueList.h \
+	DerivedSources/GdomCSSVariablesDeclaration.cpp \
+	DerivedSources/GdomCSSVariablesDeclaration.h \
+	DerivedSources/GdomCSSVariablesRule.cpp \
+	DerivedSources/GdomCSSVariablesRule.h \
+	DerivedSources/GdomCanvasGradient.cpp \
+	DerivedSources/GdomCanvasGradient.h \
+	DerivedSources/GdomCanvasPattern.cpp \
+	DerivedSources/GdomCanvasPattern.h \
+	DerivedSources/GdomCanvasPixelArray.cpp \
+	DerivedSources/GdomCanvasPixelArray.h \
+	DerivedSources/GdomCanvasRenderingContext2D.cpp \
+	DerivedSources/GdomCanvasRenderingContext2D.h \
+	DerivedSources/GdomCharacterData.cpp \
+	DerivedSources/GdomCharacterData.h \
+	DerivedSources/GdomClipboard.cpp \
+	DerivedSources/GdomClipboard.h \
+	DerivedSources/GdomComment.cpp \
+	DerivedSources/GdomComment.h \
+	DerivedSources/GdomConsole.cpp \
+	DerivedSources/GdomConsole.h \
+	DerivedSources/GdomCounter.cpp \
+	DerivedSources/GdomCounter.h \
+	DerivedSources/GdomDOMCoreException.cpp \
+	DerivedSources/GdomDOMCoreException.h \
+	DerivedSources/GdomDOMImplementation.cpp \
+	DerivedSources/GdomDOMImplementation.h \
+	DerivedSources/GdomDOMParser.cpp \
+	DerivedSources/GdomDOMParser.h \
+	DerivedSources/GdomDOMSelection.cpp \
+	DerivedSources/GdomDOMSelection.h \
+	DerivedSources/GdomDOMWindow.cpp \
+	DerivedSources/GdomDOMWindow.h \
+	DerivedSources/GdomDocument.cpp \
+	DerivedSources/GdomDocument.h \
+	DerivedSources/GdomDocumentFragment.cpp \
+	DerivedSources/GdomDocumentFragment.h \
+	DerivedSources/GdomDocumentType.cpp \
+	DerivedSources/GdomDocumentType.h \
+	DerivedSources/GdomElement.cpp \
+	DerivedSources/GdomElement.h \
+	DerivedSources/GdomEntity.cpp \
+	DerivedSources/GdomEntity.h \
+	DerivedSources/GdomEntityReference.cpp \
+	DerivedSources/GdomEntityReference.h \
+	DerivedSources/GdomEvent.cpp \
+	DerivedSources/GdomEvent.h \
+	DerivedSources/GdomEventException.cpp \
+	DerivedSources/GdomEventException.h \
+	DerivedSources/GdomFile.cpp \
+	DerivedSources/GdomFile.h \
+	DerivedSources/GdomFileList.cpp \
+	DerivedSources/GdomFileList.h \
+	DerivedSources/GdomHTMLAnchorElement.cpp \
+	DerivedSources/GdomHTMLAnchorElement.h \
+	DerivedSources/GdomHTMLAppletElement.cpp \
+	DerivedSources/GdomHTMLAppletElement.h \
+	DerivedSources/GdomHTMLAreaElement.cpp \
+	DerivedSources/GdomHTMLAreaElement.h \
+	DerivedSources/GdomHTMLBRElement.cpp \
+	DerivedSources/GdomHTMLBRElement.h \
+	DerivedSources/GdomHTMLBaseElement.cpp \
+	DerivedSources/GdomHTMLBaseElement.h \
+	DerivedSources/GdomHTMLBaseFontElement.cpp \
+	DerivedSources/GdomHTMLBaseFontElement.h \
+	DerivedSources/GdomHTMLBlockquoteElement.cpp \
+	DerivedSources/GdomHTMLBlockquoteElement.h \
+	DerivedSources/GdomHTMLBodyElement.cpp \
+	DerivedSources/GdomHTMLBodyElement.h \
+	DerivedSources/GdomHTMLButtonElement.cpp \
+	DerivedSources/GdomHTMLButtonElement.h \
+	DerivedSources/GdomHTMLCanvasElement.cpp \
+	DerivedSources/GdomHTMLCanvasElement.h \
+	DerivedSources/GdomHTMLCollection.cpp \
+	DerivedSources/GdomHTMLCollection.h \
+	DerivedSources/GdomHTMLDListElement.cpp \
+	DerivedSources/GdomHTMLDListElement.h \
+	DerivedSources/GdomHTMLDirectoryElement.cpp \
+	DerivedSources/GdomHTMLDirectoryElement.h \
+	DerivedSources/GdomHTMLDivElement.cpp \
+	DerivedSources/GdomHTMLDivElement.h \
+	DerivedSources/GdomHTMLDocument.cpp \
+	DerivedSources/GdomHTMLDocument.h \
+	DerivedSources/GdomHTMLElement.cpp \
+	DerivedSources/GdomHTMLElement.h \
+	DerivedSources/GdomHTMLEmbedElement.cpp \
+	DerivedSources/GdomHTMLEmbedElement.h \
+	DerivedSources/GdomHTMLFieldSetElement.cpp \
+	DerivedSources/GdomHTMLFieldSetElement.h \
+	DerivedSources/GdomHTMLFontElement.cpp \
+	DerivedSources/GdomHTMLFontElement.h \
+	DerivedSources/GdomHTMLFormElement.cpp \
+	DerivedSources/GdomHTMLFormElement.h \
+	DerivedSources/GdomHTMLFrameElement.cpp \
+	DerivedSources/GdomHTMLFrameElement.h \
+	DerivedSources/GdomHTMLFrameSetElement.cpp \
+	DerivedSources/GdomHTMLFrameSetElement.h \
+	DerivedSources/GdomHTMLHRElement.cpp \
+	DerivedSources/GdomHTMLHRElement.h \
+	DerivedSources/GdomHTMLHeadElement.cpp \
+	DerivedSources/GdomHTMLHeadElement.h \
+	DerivedSources/GdomHTMLHeadingElement.cpp \
+	DerivedSources/GdomHTMLHeadingElement.h \
+	DerivedSources/GdomHTMLHtmlElement.cpp \
+	DerivedSources/GdomHTMLHtmlElement.h \
+	DerivedSources/GdomHTMLIFrameElement.cpp \
+	DerivedSources/GdomHTMLIFrameElement.h \
+	DerivedSources/GdomHTMLImageElement.cpp \
+	DerivedSources/GdomHTMLImageElement.h \
+	DerivedSources/GdomHTMLInputElement.cpp \
+	DerivedSources/GdomHTMLInputElement.h \
+	DerivedSources/GdomHTMLIsIndexElement.cpp \
+	DerivedSources/GdomHTMLIsIndexElement.h \
+	DerivedSources/GdomHTMLLIElement.cpp \
+	DerivedSources/GdomHTMLLIElement.h \
+	DerivedSources/GdomHTMLLabelElement.cpp \
+	DerivedSources/GdomHTMLLabelElement.h \
+	DerivedSources/GdomHTMLLegendElement.cpp \
+	DerivedSources/GdomHTMLLegendElement.h \
+	DerivedSources/GdomHTMLLinkElement.cpp \
+	DerivedSources/GdomHTMLLinkElement.h \
+	DerivedSources/GdomHTMLMapElement.cpp \
+	DerivedSources/GdomHTMLMapElement.h \
+	DerivedSources/GdomHTMLMarqueeElement.cpp \
+	DerivedSources/GdomHTMLMarqueeElement.h \
+	DerivedSources/GdomHTMLMenuElement.cpp \
+	DerivedSources/GdomHTMLMenuElement.h \
+	DerivedSources/GdomHTMLMetaElement.cpp \
+	DerivedSources/GdomHTMLMetaElement.h \
+	DerivedSources/GdomHTMLModElement.cpp \
+	DerivedSources/GdomHTMLModElement.h \
+	DerivedSources/GdomHTMLOListElement.cpp \
+	DerivedSources/GdomHTMLOListElement.h \
+	DerivedSources/GdomHTMLObjectElement.cpp \
+	DerivedSources/GdomHTMLObjectElement.h \
+	DerivedSources/GdomHTMLOptGroupElement.cpp \
+	DerivedSources/GdomHTMLOptGroupElement.h \
+	DerivedSources/GdomHTMLOptionElement.cpp \
+	DerivedSources/GdomHTMLOptionElement.h \
+	DerivedSources/GdomHTMLOptionsCollection.cpp \
+	DerivedSources/GdomHTMLOptionsCollection.h \
+	DerivedSources/GdomHTMLParagraphElement.cpp \
+	DerivedSources/GdomHTMLParagraphElement.h \
+	DerivedSources/GdomHTMLParamElement.cpp \
+	DerivedSources/GdomHTMLParamElement.h \
+	DerivedSources/GdomHTMLPreElement.cpp \
+	DerivedSources/GdomHTMLPreElement.h \
+	DerivedSources/GdomHTMLQuoteElement.cpp \
+	DerivedSources/GdomHTMLQuoteElement.h \
+	DerivedSources/GdomHTMLScriptElement.cpp \
+	DerivedSources/GdomHTMLScriptElement.h \
+	DerivedSources/GdomHTMLSelectElement.cpp \
+	DerivedSources/GdomHTMLSelectElement.h \
+	DerivedSources/GdomHTMLStyleElement.cpp \
+	DerivedSources/GdomHTMLStyleElement.h \
+	DerivedSources/GdomHTMLTableCaptionElement.cpp \
+	DerivedSources/GdomHTMLTableCaptionElement.h \
+	DerivedSources/GdomHTMLTableCellElement.cpp \
+	DerivedSources/GdomHTMLTableCellElement.h \
+	DerivedSources/GdomHTMLTableColElement.cpp \
+	DerivedSources/GdomHTMLTableColElement.h \
+	DerivedSources/GdomHTMLTableElement.cpp \
+	DerivedSources/GdomHTMLTableElement.h \
+	DerivedSources/GdomHTMLTableRowElement.cpp \
+	DerivedSources/GdomHTMLTableRowElement.h \
+	DerivedSources/GdomHTMLTableSectionElement.cpp \
+	DerivedSources/GdomHTMLTableSectionElement.h \
+	DerivedSources/GdomHTMLTextAreaElement.cpp \
+	DerivedSources/GdomHTMLTextAreaElement.h \
+	DerivedSources/GdomHTMLTitleElement.cpp \
+	DerivedSources/GdomHTMLTitleElement.h \
+	DerivedSources/GdomHTMLUListElement.cpp \
+	DerivedSources/GdomHTMLUListElement.h \
+	DerivedSources/GdomHistory.cpp \
+	DerivedSources/GdomHistory.h \
+	DerivedSources/GdomImageData.cpp \
+	DerivedSources/GdomImageData.h \
+	DerivedSources/GdomJavaScriptCallFrame.cpp \
+	DerivedSources/GdomJavaScriptCallFrame.h \
+	DerivedSources/GdomKeyboardEvent.cpp \
+	DerivedSources/GdomKeyboardEvent.h \
+	DerivedSources/GdomLocation.cpp \
+	DerivedSources/GdomLocation.h \
+	DerivedSources/GdomMediaList.cpp \
+	DerivedSources/GdomMediaList.h \
+	DerivedSources/GdomMessageEvent.cpp \
+	DerivedSources/GdomMessageEvent.h \
+	DerivedSources/GdomMimeType.cpp \
+	DerivedSources/GdomMimeType.h \
+	DerivedSources/GdomMimeTypeArray.cpp \
+	DerivedSources/GdomMimeTypeArray.h \
+	DerivedSources/GdomMouseEvent.cpp \
+	DerivedSources/GdomMouseEvent.h \
+	DerivedSources/GdomMutationEvent.cpp \
+	DerivedSources/GdomMutationEvent.h \
+	DerivedSources/GdomNamedNodeMap.cpp \
+	DerivedSources/GdomNamedNodeMap.h \
+	DerivedSources/GdomNavigator.cpp \
+	DerivedSources/GdomNavigator.h \
+	DerivedSources/GdomNode.cpp \
+	DerivedSources/GdomNode.h \
+	DerivedSources/GdomNodeFilter.cpp \
+	DerivedSources/GdomNodeFilter.h \
+	DerivedSources/GdomNodeIterator.cpp \
+	DerivedSources/GdomNodeIterator.h \
+	DerivedSources/GdomNodeList.cpp \
+	DerivedSources/GdomNodeList.h \
+	DerivedSources/GdomNotation.cpp \
+	DerivedSources/GdomNotation.h \
+	DerivedSources/GdomOverflowEvent.cpp \
+	DerivedSources/GdomOverflowEvent.h \
+	DerivedSources/GdomPlugin.cpp \
+	DerivedSources/GdomPlugin.h \
+	DerivedSources/GdomPluginArray.cpp \
+	DerivedSources/GdomPluginArray.h \
+	DerivedSources/GdomProcessingInstruction.cpp \
+	DerivedSources/GdomProcessingInstruction.h \
+	DerivedSources/GdomProgressEvent.cpp \
+	DerivedSources/GdomProgressEvent.h \
+	DerivedSources/GdomRange.cpp \
+	DerivedSources/GdomRange.h \
+	DerivedSources/GdomRangeException.cpp \
+	DerivedSources/GdomRangeException.h \
+	DerivedSources/GdomRect.cpp \
+	DerivedSources/GdomRect.h \
+	DerivedSources/GdomScreen.cpp \
+	DerivedSources/GdomScreen.h \
+	DerivedSources/GdomStyleSheet.cpp \
+	DerivedSources/GdomStyleSheet.h \
+	DerivedSources/GdomStyleSheetList.cpp \
+	DerivedSources/GdomStyleSheetList.h \
+	DerivedSources/GdomText.cpp \
+	DerivedSources/GdomText.h \
+	DerivedSources/GdomTextEvent.cpp \
+	DerivedSources/GdomTextEvent.h \
+	DerivedSources/GdomTreeWalker.cpp \
+	DerivedSources/GdomTreeWalker.h \
+	DerivedSources/GdomUIEvent.cpp \
+	DerivedSources/GdomUIEvent.h \
+	DerivedSources/GdomWebKitAnimationEvent.cpp \
+	DerivedSources/GdomWebKitAnimationEvent.h \
+	DerivedSources/GdomWebKitCSSTransformValue.cpp \
+	DerivedSources/GdomWebKitCSSTransformValue.h \
+	DerivedSources/GdomWebKitTransitionEvent.cpp \
+	DerivedSources/GdomWebKitTransitionEvent.h \
+	DerivedSources/GdomWheelEvent.cpp \
+	DerivedSources/GdomWheelEvent.h \
+	DerivedSources/GdomXMLHttpRequest.cpp \
+	DerivedSources/GdomXMLHttpRequest.h \
+	DerivedSources/GdomXMLHttpRequestException.cpp \
+	DerivedSources/GdomXMLHttpRequestException.h \
+	DerivedSources/GdomXMLHttpRequestProgressEvent.cpp \
+	DerivedSources/GdomXMLHttpRequestUpload.cpp \
+	DerivedSources/GdomXMLHttpRequestUpload.h \
+	DerivedSources/GdomXMLSerializer.cpp \
+	DerivedSources/GdomXMLSerializer.h \
+	DerivedSources/GdomXSLTProcessor.cpp \
+	DerivedSources/GdomXSLTProcessor.h \
+	DerivedSources/PrivateGdomAttr.cpp \
+	DerivedSources/PrivateGdomAttr.h \
+	DerivedSources/PrivateGdomBarInfo.cpp \
+	DerivedSources/PrivateGdomBarInfo.h \
+	DerivedSources/PrivateGdomCDATASection.cpp \
+	DerivedSources/PrivateGdomCDATASection.h \
+	DerivedSources/PrivateGdomCSSCharsetRule.cpp \
+	DerivedSources/PrivateGdomCSSCharsetRule.h \
+	DerivedSources/PrivateGdomCSSFontFaceRule.cpp \
+	DerivedSources/PrivateGdomCSSFontFaceRule.h \
+	DerivedSources/PrivateGdomCSSImportRule.cpp \
+	DerivedSources/PrivateGdomCSSImportRule.h \
+	DerivedSources/PrivateGdomCSSMediaRule.cpp \
+	DerivedSources/PrivateGdomCSSMediaRule.h \
+	DerivedSources/PrivateGdomCSSPageRule.cpp \
+	DerivedSources/PrivateGdomCSSPageRule.h \
+	DerivedSources/PrivateGdomCSSPrimitiveValue.cpp \
+	DerivedSources/PrivateGdomCSSPrimitiveValue.h \
+	DerivedSources/PrivateGdomCSSRule.cpp \
+	DerivedSources/PrivateGdomCSSRule.h \
+	DerivedSources/PrivateGdomCSSRuleList.cpp \
+	DerivedSources/PrivateGdomCSSRuleList.h \
+	DerivedSources/PrivateGdomCSSStyleDeclaration.cpp \
+	DerivedSources/PrivateGdomCSSStyleDeclaration.h \
+	DerivedSources/PrivateGdomCSSStyleRule.cpp \
+	DerivedSources/PrivateGdomCSSStyleRule.h \
+	DerivedSources/PrivateGdomCSSStyleSheet.cpp \
+	DerivedSources/PrivateGdomCSSStyleSheet.h \
+	DerivedSources/PrivateGdomCSSValue.cpp \
+	DerivedSources/PrivateGdomCSSValue.h \
+	DerivedSources/PrivateGdomCSSValueList.cpp \
+	DerivedSources/PrivateGdomCSSValueList.h \
+	DerivedSources/PrivateGdomCSSVariablesDeclaration.cpp \
+	DerivedSources/PrivateGdomCSSVariablesDeclaration.h \
+	DerivedSources/PrivateGdomCSSVariablesRule.cpp \
+	DerivedSources/PrivateGdomCSSVariablesRule.h \
+	DerivedSources/PrivateGdomCanvasGradient.cpp \
+	DerivedSources/PrivateGdomCanvasGradient.h \
+	DerivedSources/PrivateGdomCanvasPattern.cpp \
+	DerivedSources/PrivateGdomCanvasPattern.h \
+	DerivedSources/PrivateGdomCanvasPixelArray.cpp \
+	DerivedSources/PrivateGdomCanvasPixelArray.h \
+	DerivedSources/PrivateGdomCanvasRenderingContext2D.cpp \
+	DerivedSources/PrivateGdomCanvasRenderingContext2D.h \
+	DerivedSources/PrivateGdomCharacterData.cpp \
+	DerivedSources/PrivateGdomCharacterData.h \
+	DerivedSources/PrivateGdomClipboard.cpp \
+	DerivedSources/PrivateGdomClipboard.h \
+	DerivedSources/PrivateGdomComment.cpp \
+	DerivedSources/PrivateGdomComment.h \
+	DerivedSources/PrivateGdomConsole.cpp \
+	DerivedSources/PrivateGdomConsole.h \
+	DerivedSources/PrivateGdomCounter.cpp \
+	DerivedSources/PrivateGdomCounter.h \
+	DerivedSources/PrivateGdomDOMCoreException.cpp \
+	DerivedSources/PrivateGdomDOMCoreException.h \
+	DerivedSources/PrivateGdomDOMImplementation.cpp \
+	DerivedSources/PrivateGdomDOMImplementation.h \
+	DerivedSources/PrivateGdomDOMParser.cpp \
+	DerivedSources/PrivateGdomDOMParser.h \
+	DerivedSources/PrivateGdomDOMSelection.cpp \
+	DerivedSources/PrivateGdomDOMSelection.h \
+	DerivedSources/PrivateGdomDOMWindow.cpp \
+	DerivedSources/PrivateGdomDOMWindow.h \
+	DerivedSources/PrivateGdomDocument.cpp \
+	DerivedSources/PrivateGdomDocument.h \
+	DerivedSources/PrivateGdomDocumentFragment.cpp \
+	DerivedSources/PrivateGdomDocumentFragment.h \
+	DerivedSources/PrivateGdomDocumentType.cpp \
+	DerivedSources/PrivateGdomDocumentType.h \
+	DerivedSources/PrivateGdomElement.cpp \
+	DerivedSources/PrivateGdomElement.h \
+	DerivedSources/PrivateGdomEntity.cpp \
+	DerivedSources/PrivateGdomEntity.h \
+	DerivedSources/PrivateGdomEntityReference.cpp \
+	DerivedSources/PrivateGdomEntityReference.h \
+	DerivedSources/PrivateGdomEvent.cpp \
+	DerivedSources/PrivateGdomEvent.h \
+	DerivedSources/PrivateGdomEventException.cpp \
+	DerivedSources/PrivateGdomEventException.h \
+	DerivedSources/PrivateGdomFile.cpp \
+	DerivedSources/PrivateGdomFile.h \
+	DerivedSources/PrivateGdomFileList.cpp \
+	DerivedSources/PrivateGdomFileList.h \
+	DerivedSources/PrivateGdomHTMLAnchorElement.cpp \
+	DerivedSources/PrivateGdomHTMLAnchorElement.h \
+	DerivedSources/PrivateGdomHTMLAppletElement.cpp \
+	DerivedSources/PrivateGdomHTMLAppletElement.h \
+	DerivedSources/PrivateGdomHTMLAreaElement.cpp \
+	DerivedSources/PrivateGdomHTMLAreaElement.h \
+	DerivedSources/PrivateGdomHTMLBRElement.cpp \
+	DerivedSources/PrivateGdomHTMLBRElement.h \
+	DerivedSources/PrivateGdomHTMLBaseElement.cpp \
+	DerivedSources/PrivateGdomHTMLBaseElement.h \
+	DerivedSources/PrivateGdomHTMLBaseFontElement.cpp \
+	DerivedSources/PrivateGdomHTMLBaseFontElement.h \
+	DerivedSources/PrivateGdomHTMLBlockquoteElement.cpp \
+	DerivedSources/PrivateGdomHTMLBlockquoteElement.h \
+	DerivedSources/PrivateGdomHTMLBodyElement.cpp \
+	DerivedSources/PrivateGdomHTMLBodyElement.h \
+	DerivedSources/PrivateGdomHTMLButtonElement.cpp \
+	DerivedSources/PrivateGdomHTMLButtonElement.h \
+	DerivedSources/PrivateGdomHTMLCanvasElement.cpp \
+	DerivedSources/PrivateGdomHTMLCanvasElement.h \
+	DerivedSources/PrivateGdomHTMLCollection.cpp \
+	DerivedSources/PrivateGdomHTMLCollection.h \
+	DerivedSources/PrivateGdomHTMLDListElement.cpp \
+	DerivedSources/PrivateGdomHTMLDListElement.h \
+	DerivedSources/PrivateGdomHTMLDirectoryElement.cpp \
+	DerivedSources/PrivateGdomHTMLDirectoryElement.h \
+	DerivedSources/PrivateGdomHTMLDivElement.cpp \
+	DerivedSources/PrivateGdomHTMLDivElement.h \
+	DerivedSources/PrivateGdomHTMLDocument.cpp \
+	DerivedSources/PrivateGdomHTMLDocument.h \
+	DerivedSources/PrivateGdomHTMLElement.cpp \
+	DerivedSources/PrivateGdomHTMLElement.h \
+	DerivedSources/PrivateGdomHTMLEmbedElement.cpp \
+	DerivedSources/PrivateGdomHTMLEmbedElement.h \
+	DerivedSources/PrivateGdomHTMLFieldSetElement.cpp \
+	DerivedSources/PrivateGdomHTMLFieldSetElement.h \
+	DerivedSources/PrivateGdomHTMLFontElement.cpp \
+	DerivedSources/PrivateGdomHTMLFontElement.h \
+	DerivedSources/PrivateGdomHTMLFormElement.cpp \
+	DerivedSources/PrivateGdomHTMLFormElement.h \
+	DerivedSources/PrivateGdomHTMLFrameElement.cpp \
+	DerivedSources/PrivateGdomHTMLFrameElement.h \
+	DerivedSources/PrivateGdomHTMLFrameSetElement.cpp \
+	DerivedSources/PrivateGdomHTMLFrameSetElement.h \
+	DerivedSources/PrivateGdomHTMLHRElement.cpp \
+	DerivedSources/PrivateGdomHTMLHRElement.h \
+	DerivedSources/PrivateGdomHTMLHeadElement.cpp \
+	DerivedSources/PrivateGdomHTMLHeadElement.h \
+	DerivedSources/PrivateGdomHTMLHeadingElement.cpp \
+	DerivedSources/PrivateGdomHTMLHeadingElement.h \
+	DerivedSources/PrivateGdomHTMLHtmlElement.cpp \
+	DerivedSources/PrivateGdomHTMLHtmlElement.h \
+	DerivedSources/PrivateGdomHTMLIFrameElement.cpp \
+	DerivedSources/PrivateGdomHTMLIFrameElement.h \
+	DerivedSources/PrivateGdomHTMLImageElement.cpp \
+	DerivedSources/PrivateGdomHTMLImageElement.h \
+	DerivedSources/PrivateGdomHTMLInputElement.cpp \
+	DerivedSources/PrivateGdomHTMLInputElement.h \
+	DerivedSources/PrivateGdomHTMLIsIndexElement.cpp \
+	DerivedSources/PrivateGdomHTMLIsIndexElement.h \
+	DerivedSources/PrivateGdomHTMLLIElement.cpp \
+	DerivedSources/PrivateGdomHTMLLIElement.h \
+	DerivedSources/PrivateGdomHTMLLabelElement.cpp \
+	DerivedSources/PrivateGdomHTMLLabelElement.h \
+	DerivedSources/PrivateGdomHTMLLegendElement.cpp \
+	DerivedSources/PrivateGdomHTMLLegendElement.h \
+	DerivedSources/PrivateGdomHTMLLinkElement.cpp \
+	DerivedSources/PrivateGdomHTMLLinkElement.h \
+	DerivedSources/PrivateGdomHTMLMapElement.cpp \
+	DerivedSources/PrivateGdomHTMLMapElement.h \
+	DerivedSources/PrivateGdomHTMLMarqueeElement.cpp \
+	DerivedSources/PrivateGdomHTMLMarqueeElement.h \
+	DerivedSources/PrivateGdomHTMLMenuElement.cpp \
+	DerivedSources/PrivateGdomHTMLMenuElement.h \
+	DerivedSources/PrivateGdomHTMLMetaElement.cpp \
+	DerivedSources/PrivateGdomHTMLMetaElement.h \
+	DerivedSources/PrivateGdomHTMLModElement.cpp \
+	DerivedSources/PrivateGdomHTMLModElement.h \
+	DerivedSources/PrivateGdomHTMLOListElement.cpp \
+	DerivedSources/PrivateGdomHTMLOListElement.h \
+	DerivedSources/PrivateGdomHTMLObjectElement.cpp \
+	DerivedSources/PrivateGdomHTMLObjectElement.h \
+	DerivedSources/PrivateGdomHTMLOptGroupElement.cpp \
+	DerivedSources/PrivateGdomHTMLOptGroupElement.h \
+	DerivedSources/PrivateGdomHTMLOptionElement.cpp \
+	DerivedSources/PrivateGdomHTMLOptionElement.h \
+	DerivedSources/PrivateGdomHTMLOptionsCollection.cpp \
+	DerivedSources/PrivateGdomHTMLOptionsCollection.h \
+	DerivedSources/PrivateGdomHTMLParagraphElement.cpp \
+	DerivedSources/PrivateGdomHTMLParagraphElement.h \
+	DerivedSources/PrivateGdomHTMLParamElement.cpp \
+	DerivedSources/PrivateGdomHTMLParamElement.h \
+	DerivedSources/PrivateGdomHTMLPreElement.cpp \
+	DerivedSources/PrivateGdomHTMLPreElement.h \
+	DerivedSources/PrivateGdomHTMLQuoteElement.cpp \
+	DerivedSources/PrivateGdomHTMLQuoteElement.h \
+	DerivedSources/PrivateGdomHTMLScriptElement.cpp \
+	DerivedSources/PrivateGdomHTMLScriptElement.h \
+	DerivedSources/PrivateGdomHTMLSelectElement.cpp \
+	DerivedSources/PrivateGdomHTMLSelectElement.h \
+	DerivedSources/PrivateGdomHTMLStyleElement.cpp \
+	DerivedSources/PrivateGdomHTMLStyleElement.h \
+	DerivedSources/PrivateGdomHTMLTableCaptionElement.cpp \
+	DerivedSources/PrivateGdomHTMLTableCaptionElement.h \
+	DerivedSources/PrivateGdomHTMLTableCellElement.cpp \
+	DerivedSources/PrivateGdomHTMLTableCellElement.h \
+	DerivedSources/PrivateGdomHTMLTableColElement.cpp \
+	DerivedSources/PrivateGdomHTMLTableColElement.h \
+	DerivedSources/PrivateGdomHTMLTableElement.cpp \
+	DerivedSources/PrivateGdomHTMLTableElement.h \
+	DerivedSources/PrivateGdomHTMLTableRowElement.cpp \
+	DerivedSources/PrivateGdomHTMLTableRowElement.h \
+	DerivedSources/PrivateGdomHTMLTableSectionElement.cpp \
+	DerivedSources/PrivateGdomHTMLTableSectionElement.h \
+	DerivedSources/PrivateGdomHTMLTextAreaElement.cpp \
+	DerivedSources/PrivateGdomHTMLTextAreaElement.h \
+	DerivedSources/PrivateGdomHTMLTitleElement.cpp \
+	DerivedSources/PrivateGdomHTMLTitleElement.h \
+	DerivedSources/PrivateGdomHTMLUListElement.cpp \
+	DerivedSources/PrivateGdomHTMLUListElement.h \
+	DerivedSources/PrivateGdomHistory.cpp \
+	DerivedSources/PrivateGdomHistory.h \
+	DerivedSources/PrivateGdomImageData.cpp \
+	DerivedSources/PrivateGdomImageData.h \
+	DerivedSources/PrivateGdomJavaScriptCallFrame.cpp \
+	DerivedSources/PrivateGdomJavaScriptCallFrame.h \
+	DerivedSources/PrivateGdomKeyboardEvent.cpp \
+	DerivedSources/PrivateGdomKeyboardEvent.h \
+	DerivedSources/PrivateGdomLocation.cpp \
+	DerivedSources/PrivateGdomLocation.h \
+	DerivedSources/PrivateGdomMediaList.cpp \
+	DerivedSources/PrivateGdomMediaList.h \
+	DerivedSources/PrivateGdomMessageEvent.cpp \
+	DerivedSources/PrivateGdomMessageEvent.h \
+	DerivedSources/PrivateGdomMimeType.cpp \
+	DerivedSources/PrivateGdomMimeType.h \
+	DerivedSources/PrivateGdomMimeTypeArray.cpp \
+	DerivedSources/PrivateGdomMimeTypeArray.h \
+	DerivedSources/PrivateGdomMouseEvent.cpp \
+	DerivedSources/PrivateGdomMouseEvent.h \
+	DerivedSources/PrivateGdomMutationEvent.cpp \
+	DerivedSources/PrivateGdomMutationEvent.h \
+	DerivedSources/PrivateGdomNamedNodeMap.cpp \
+	DerivedSources/PrivateGdomNamedNodeMap.h \
+	DerivedSources/PrivateGdomNavigator.cpp \
+	DerivedSources/PrivateGdomNavigator.h \
+	DerivedSources/PrivateGdomNode.cpp \
+	DerivedSources/PrivateGdomNode.h \
+	DerivedSources/PrivateGdomNodeFilter.cpp \
+	DerivedSources/PrivateGdomNodeFilter.h \
+	DerivedSources/PrivateGdomNodeIterator.cpp \
+	DerivedSources/PrivateGdomNodeIterator.h \
+	DerivedSources/PrivateGdomNodeList.cpp \
+	DerivedSources/PrivateGdomNodeList.h \
+	DerivedSources/PrivateGdomNotation.cpp \
+	DerivedSources/PrivateGdomNotation.h \
+	DerivedSources/PrivateGdomOverflowEvent.cpp \
+	DerivedSources/PrivateGdomOverflowEvent.h \
+	DerivedSources/PrivateGdomPlugin.cpp \
+	DerivedSources/PrivateGdomPlugin.h \
+	DerivedSources/PrivateGdomPluginArray.cpp \
+	DerivedSources/PrivateGdomPluginArray.h \
+	DerivedSources/PrivateGdomProcessingInstruction.cpp \
+	DerivedSources/PrivateGdomProcessingInstruction.h \
+	DerivedSources/PrivateGdomProgressEvent.cpp \
+	DerivedSources/PrivateGdomProgressEvent.h \
+	DerivedSources/PrivateGdomRange.cpp \
+	DerivedSources/PrivateGdomRange.h \
+	DerivedSources/PrivateGdomRangeException.cpp \
+	DerivedSources/PrivateGdomRangeException.h \
+	DerivedSources/PrivateGdomRect.cpp \
+	DerivedSources/PrivateGdomRect.h \
+	DerivedSources/PrivateGdomScreen.cpp \
+	DerivedSources/PrivateGdomScreen.h \
+	DerivedSources/PrivateGdomStyleSheet.cpp \
+	DerivedSources/PrivateGdomStyleSheet.h \
+	DerivedSources/PrivateGdomStyleSheetList.cpp \
+	DerivedSources/PrivateGdomStyleSheetList.h \
+	DerivedSources/PrivateGdomText.cpp \
+	DerivedSources/PrivateGdomText.h \
+	DerivedSources/PrivateGdomTextEvent.cpp \
+	DerivedSources/PrivateGdomTextEvent.h \
+	DerivedSources/PrivateGdomTreeWalker.cpp \
+	DerivedSources/PrivateGdomTreeWalker.h \
+	DerivedSources/PrivateGdomUIEvent.cpp \
+	DerivedSources/PrivateGdomUIEvent.h \
+	DerivedSources/PrivateGdomWebKitAnimationEvent.cpp \
+	DerivedSources/PrivateGdomWebKitAnimationEvent.h \
+	DerivedSources/PrivateGdomWebKitCSSTransformValue.cpp \
+	DerivedSources/PrivateGdomWebKitCSSTransformValue.h \
+	DerivedSources/PrivateGdomWebKitTransitionEvent.cpp \
+	DerivedSources/PrivateGdomWebKitTransitionEvent.h \
+	DerivedSources/PrivateGdomWheelEvent.cpp \
+	DerivedSources/PrivateGdomWheelEvent.h \
+	DerivedSources/PrivateGdomXMLHttpRequest.cpp \
+	DerivedSources/PrivateGdomXMLHttpRequest.h \
+	DerivedSources/PrivateGdomXMLHttpRequestException.cpp \
+	DerivedSources/PrivateGdomXMLHttpRequestException.h \
+	DerivedSources/PrivateGdomXMLHttpRequestProgressEvent.cpp \
+	DerivedSources/PrivateGdomXMLHttpRequestUpload.cpp \
+	DerivedSources/PrivateGdomXMLHttpRequestUpload.h \
+	DerivedSources/PrivateGdomXMLSerializer.cpp \
+	DerivedSources/PrivateGdomXMLSerializer.h \
+	DerivedSources/PrivateGdomXSLTProcessor.cpp \
+	DerivedSources/PrivateGdomXSLTProcessor.h  \
+	WebCore/bindings/gdom/GDOMHTMLElementWrapperFactory.cpp \
+	WebCore/bindings/gdom/GDOMHTMLElementWrapperFactory.h 
 
 IDL_BINDINGS +=  \
 	WebCore/css/Counter.idl \
@@ -701,6 +1284,16 @@
 	WebCore/bindings/js/ScriptController.cpp \
 	WebCore/bindings/js/ScriptController.h \
 	WebCore/bindings/js/StringSourceProvider.h \
+	WebCore/bindings/gdom/GDOMBinding.cpp \
+	WebCore/bindings/gdom/GDOMBinding.h \
+	WebCore/bindings/gdom/GdomDOMObject.cpp \
+	WebCore/bindings/gdom/GdomDOMObject.h \
+	WebCore/bindings/gdom/PrivateGdomDOMObject.cpp \
+	WebCore/bindings/gdom/PrivateGdomDOMObject.h \
+	WebCore/bindings/gdom/GdomEventTargetNode.cpp \
+	WebCore/bindings/gdom/GdomEventTargetNode.h \
+	WebCore/bindings/gdom/PrivateGdomEventTargetNode.cpp \
+	WebCore/bindings/gdom/PrivateGdomEventTargetNode.h \
 	WebCore/bridge/NP_jsobject.cpp \
 	WebCore/bridge/NP_jsobject.h \
 	WebCore/bridge/c/c_class.cpp \
@@ -2008,9 +2601,12 @@
 # ----
 if ENABLE_OFFLINE_WEB_APPLICATIONS
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_OFFLINE_WEB_APPLICATIONS=1
+FEATURE_DEFINES_GDOM += ENABLE_OFFLINE_WEB_APPLICATIONS=1
 
 webcore_built_sources += \
-	DerivedSources/JSDOMApplicationCache.cpp
+	DerivedSources/JSDOMApplicationCache.cpp \
+	DerivedSources/GdomDOMApplicationCache.cpp \
+	DerivedSources/PrivateGdomDOMApplicationCache.cpp
 
 IDL_BINDINGS += \
 	WebCore/loader/appcache/DOMApplicationCache.idl
@@ -2052,6 +2648,7 @@
 # ----
 if ENABLE_DATABASE
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_DATABASE=1
+FEATURE_DEFINES_GDOM += ENABLE_DATABASE=1
 
 webcore_built_sources += \
 	DerivedSources/JSDatabase.cpp \
@@ -2063,7 +2660,27 @@
 	DerivedSources/JSSQLResultSetRowList.cpp \
 	DerivedSources/JSSQLResultSetRowList.h \
 	DerivedSources/JSSQLTransaction.cpp \
-	DerivedSources/JSSQLTransaction.h
+	DerivedSources/JSSQLTransaction.h \
+	DerivedSources/GdomDatabase.cpp \
+	DerivedSources/GdomDatabase.h \
+	DerivedSources/GdomSQLError.cpp \
+	DerivedSources/GdomSQLError.h \
+	DerivedSources/GdomSQLResultSet.cpp \
+	DerivedSources/GdomSQLResultSet.h \
+	DerivedSources/GdomSQLResultSetRowList.cpp \
+	DerivedSources/GdomSQLResultSetRowList.h \
+	DerivedSources/GdomSQLTransaction.cpp \
+	DerivedSources/GdomSQLTransaction.h \
+	DerivedSources/PrivateGdomDatabase.cpp \
+	DerivedSources/PrivateGdomDatabase.h \
+	DerivedSources/PrivateGdomSQLError.cpp \
+	DerivedSources/PrivateGdomSQLError.h \
+	DerivedSources/PrivateGdomSQLResultSet.cpp \
+	DerivedSources/PrivateGdomSQLResultSet.h \
+	DerivedSources/PrivateGdomSQLResultSetRowList.cpp \
+	DerivedSources/PrivateGdomSQLResultSetRowList.h \
+	DerivedSources/PrivateGdomSQLTransaction.cpp \
+	DerivedSources/PrivateGdomSQLTransaction.h
 
 IDL_BINDINGS += \
 	WebCore/storage/Database.idl \
@@ -2138,12 +2755,21 @@
 # ----
 if ENABLE_DOM_STORAGE
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_DOM_STORAGE=1
+FEATURE_DEFINES_GDOM += ENABLE_DOM_STORAGE=1
 
 webcore_built_sources += \
 	DerivedSources/JSStorage.cpp \
 	DerivedSources/JSStorage.h \
 	DerivedSources/JSStorageEvent.cpp \
-	DerivedSources/JSStorageEvent.h
+	DerivedSources/JSStorageEvent.h \
+	DerivedSources/GdomStorage.cpp \
+	DerivedSources/GdomStorage.h \
+	DerivedSources/GdomStorageEvent.cpp \
+	DerivedSources/GdomStorageEvent.h \
+	DerivedSources/PrivateGdomStorage.cpp \
+	DerivedSources/PrivateGdomStorage.h \
+	DerivedSources/PrivateGdomStorageEvent.cpp \
+	DerivedSources/PrivateGdomStorageEvent.h
 
 IDL_BINDINGS += \
 	WebCore/storage/Storage.idl \
@@ -2203,6 +2829,7 @@
 # ----
 if ENABLE_VIDEO
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_VIDEO=1
+FEATURE_DEFINES_GDOM += ENABLE_VIDEO=1
 
 HTML_FEATURES += ENABLE_VIDEO=1
 webcore_cppflags += -DENABLE_VIDEO=1
